/* Anurag Bhandari
 * 03 August 2009
 *
 * Customers.cpp:
 * Contains the data members and functions that are required to perform various things with the customers and their bills.
 */

#include<iostream>
#include<string>

using namespace std;

class Customers {
  /* Data members */
  int acc_no;
  string customer_name;
  string customer_address;
  int line_type;
  int no_of_local_mins, no_of_sms;
  int no_of_aus_mins, no_of_hk_mins, no_of_malay_mins, no_of_indo_mins, no_of_thai_mins;
  int no_of_extra_local_mins, no_of_extra_sms;
  float total_local_charges, total_dist_charges, total_sms_charges, calculated_bill;
  public:
    /* Member functions */
    void createCustomer();
    int getAccNo();
    void setCallInfo();
    void computeBill();
    void showBill();
  /* Constructor */
  Customers() {
    // Initialization of private class members data members cannot be done directly in class.
    // It has to be done in the constructor.
    // http://www.csit.parkland.edu/~dbock/Class/csc125/Lecture/Constructors.html
    no_of_local_mins = no_of_sms = 0;
    no_of_aus_mins = no_of_hk_mins = no_of_malay_mins = no_of_indo_mins = no_of_thai_mins = 0;
    no_of_extra_local_mins = no_of_extra_sms = 0;
    total_local_charges = total_dist_charges = total_sms_charges = calculated_bill = 0.0;
  }
};

/* Creates a customer by asking for basic info about him/her */
void Customers::createCustomer() {
  cout<<"Enter account number: ";
  cin>>acc_no;
  cout<<"Enter customer name: ";
  cin>>customer_name;
  cout<<"Enter customer address: ";
  cin>>customer_address;
  cout<<"Enter phone line type (0 - HOME LOCAL; 1 - MOBILE LOCAL; 2 - HOME DISTANCE; 3 - MOBILE DISTANCE):"<<endl;
  cin>>line_type;
}

/* Returns the account number of the customer */
int Customers::getAccNo() {
  return(acc_no);
}

/* Asks for various call information parameters and sets them for the customer */
void Customers::setCallInfo() {
  cout<<"Enter no of mins of local calls: ";
  cin>>no_of_local_mins;
  if(line_type==2 || line_type==3) {
    cout<<"Enter no of mins of Australia calls: ";
    cin>>no_of_aus_mins;
    cout<<"Enter no of mins of Hong Kong calls: ";
    cin>>no_of_hk_mins;
    cout<<"Enter no of mins of Malaysia calls: ";
    cin>>no_of_malay_mins;
    cout<<"Enter no of mins of Indonesia calls: ";
    cin>>no_of_indo_mins;
    cout<<"Enter no of mins of Thailand calls: ";
    cin>>no_of_thai_mins;
  }
  if(line_type==1 || line_type==3) {
    cout<<"Enter no of SMS: ";
    cin>>no_of_sms;
  }
}

/* Calculates the various aspects and parts of the phone bill based on the charges table provided */
void Customers::computeBill() {
  // 100 mins of calls and 200 SMS are free. The charges will be calculated on the 'extra' mins or SMSes, if any.
  if(no_of_local_mins>100)
    no_of_extra_local_mins = no_of_local_mins - 100;
  if(no_of_sms>200)
    no_of_extra_sms = no_of_sms - 200;

  // Based on the type of connection of the customer, several charges for the bill are calculated
  switch(line_type) {
    // Home local
    case 0:
      total_local_charges = (float)(0.08*no_of_extra_local_mins);
      calculated_bill = (float)(10 + total_local_charges);
      break;
    // Mobile local
    case 1:
      total_local_charges = (float)(0.20*no_of_extra_local_mins);
      total_sms_charges = (float)(0.05*no_of_extra_sms);
      calculated_bill = (float)(25 + total_local_charges + total_sms_charges);
      calculated_bill = (25 + 0.20*no_of_extra_local_mins + 0.05*no_of_extra_sms);
      break;
    // Home distance
    case 2:
      total_local_charges = (float)(0.08*no_of_extra_local_mins);
      total_dist_charges = (float)(0.60*no_of_aus_mins + 0.50*no_of_hk_mins + 0.20*no_of_malay_mins + 1.20*no_of_indo_mins + 1.15*no_of_thai_mins);
      calculated_bill = (float)(10 + 5 + total_local_charges + total_dist_charges);
      break;
    // Mobile distance
    case 3:
      total_local_charges = (float)(0.20*no_of_extra_local_mins);
      total_dist_charges = (float)(0.60*no_of_aus_mins + 0.50*no_of_hk_mins + 0.20*no_of_malay_mins + 1.20*no_of_indo_mins + 1.15*no_of_thai_mins);
      total_sms_charges = (float)(0.05*no_of_extra_sms);
      calculated_bill = (float)(25 + 5 + total_local_charges + total_dist_charges + total_sms_charges);
      break;
  }
}

/* Display the bill with various charges calculated above */
void Customers::showBill() {
  cout<<"\nC U S T O M E R  B I L L"<<endl;
  for(int i=0; i<30; i++)
    cout<<"=";
  cout<<"\nAccount Number: "<<acc_no;
  cout<<"\nCustomer Name: "<<customer_name;
  cout<<"\nCustomer Address: "<<customer_address;
  cout<<"\nTotal Local Charges: $"<<total_local_charges;
  cout<<"\nTotal Distance Charges: $"<<total_dist_charges;
  cout<<"\nTotal SMS Charges: $"<<total_sms_charges;
  cout<<"\nTotal Bill: $"<<calculated_bill<<endl;
}